// This file is auto-generated, don't edit it. Thanks.
package com.aliyun.sample;

import com.aliyun.tea.*;
import com.aliyun.ecs20140526.*;
import com.aliyun.ecs20140526.models.*;
import com.aliyun.teaopenapi.*;
import com.aliyun.teaopenapi.models.*;
import com.aliyun.teautil.*;
import com.aliyun.teaconsole.*;
import com.aliyun.darabonba.env.*;
import com.aliyun.darabonba.array.*;

public class Sample {

    /**
    * Initialization  初始化公共请求参数
    */
    public static com.aliyun.ecs20140526.Client Initialization(String regionId) throws Exception {
        Config config = new Config();
        // 您的AccessKey ID
        config.accessKeyId = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_ID");
        // 您的AccessKey Secret
        config.accessKeySecret = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_SECRET");
        // 您的可用区ID
        config.regionId = regionId;
        return new com.aliyun.ecs20140526.Client(config);
    }

    public static void main(String[] args_) throws Exception {
        java.util.List<String> args = java.util.Arrays.asList(args_);
        // 地域Id
        String regionId = args.get(0);
        // 实例Id
        String instanceId = args.get(1);
        com.aliyun.ecs20140526.Client client = Sample.Initialization(regionId);
        // 查询升级实例规格的资源列表
        Sample.DescribeInstanceTypeResource(client, regionId, instanceId);
        // 查询升级系统盘规格或类型的资源列表
        Sample.DescribeSystemDiskResource(client, regionId, instanceId);
    }

    public static DescribeResourcesModificationRequest BuildRequest(String regionId, String instanceId) throws Exception {
        DescribeResourcesModificationRequest request = new DescribeResourcesModificationRequest()
                .setRegionId(regionId)
                .setResourceId(instanceId)
                .setMigrateAcrossZone(false)
                .setOperationType("Upgrade");
        return request;
    }

    public static void DescribeResourcesModification(com.aliyun.ecs20140526.Client client, DescribeResourcesModificationRequest request) throws Exception {
        DescribeResourcesModificationResponse response = client.describeResourcesModification(request);
        if (com.aliyun.teautil.Common.isUnset(TeaModel.buildMap(response.body.availableZones))) {
            com.aliyun.teaconsole.Client.log("availableZones is None");
            return ;
        }

        java.util.List<DescribeResourcesModificationResponseBody.DescribeResourcesModificationResponseBodyAvailableZonesAvailableZone> availableZones = response.body.availableZones.availableZone;
        for (DescribeResourcesModificationResponseBody.DescribeResourcesModificationResponseBodyAvailableZonesAvailableZone zone : availableZones) {
            String zoneId = zone.zoneId;
            java.util.List<String> results = new java.util.ArrayList<>();
            if (com.aliyun.teautil.Common.isUnset(TeaModel.buildMap(zone.availableResources))) {
                com.aliyun.teaconsole.Client.log("availableResources is None");
                return ;
            }

            java.util.List<DescribeResourcesModificationResponseBody.DescribeResourcesModificationResponseBodyAvailableZonesAvailableZoneAvailableResourcesAvailableResource> availableResources = zone.availableResources.availableResource;
            for (DescribeResourcesModificationResponseBody.DescribeResourcesModificationResponseBodyAvailableZonesAvailableZoneAvailableResourcesAvailableResource availableResource : availableResources) {
                if (com.aliyun.teautil.Common.isUnset(TeaModel.buildMap(availableResource.supportedResources))) {
                    com.aliyun.teaconsole.Client.log("supportedResources is None");
                    return ;
                }

                java.util.List<DescribeResourcesModificationResponseBody.DescribeResourcesModificationResponseBodyAvailableZonesAvailableZoneAvailableResourcesAvailableResourceSupportedResourcesSupportedResource> supportedResources = availableResource.supportedResources.supportedResource;
                for (DescribeResourcesModificationResponseBody.DescribeResourcesModificationResponseBodyAvailableZonesAvailableZoneAvailableResourcesAvailableResourceSupportedResourcesSupportedResource supportedResource : supportedResources) {
                    if (com.aliyun.teautil.Common.equalString("Available", supportedResource.status)) {
                        if (com.aliyun.teautil.Common.isUnset(results)) {
                            results = java.util.Arrays.asList(
                                supportedResource.value
                            );
                        } else {
                            results = com.aliyun.darabonba.array.Client.concat(results, java.util.Arrays.asList(
                                supportedResource.value
                            ));
                        }

                    }

                }
            }
            com.aliyun.teaconsole.Client.log("ecs in zone " + zoneId + " resource value list is " + com.aliyun.teautil.Common.toJSONString(results) + "");
        }
    }

    public static void DescribeInstanceTypeResource(com.aliyun.ecs20140526.Client client, String regionId, String instanceId) throws Exception {
        DescribeResourcesModificationRequest request = Sample.BuildRequest(regionId, instanceId);
        request.destinationResource = "InstanceType";
        Sample.DescribeResourcesModification(client, request);
    }

    public static void DescribeSystemDiskResource(com.aliyun.ecs20140526.Client client, String regionId, String instanceId) throws Exception {
        DescribeResourcesModificationRequest request = Sample.BuildRequest(regionId, instanceId);
        request.destinationResource = "SystemDisk";
        // 当参数DestinationResource取值为SystemDisk，必须同时指定InstanceType参数。
        request.instanceType = "ecs.g5.large";
        Sample.DescribeResourcesModification(client, request);
    }
}
